#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityFishingCeleExchangeCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityFishingCeleExchangeCFG> M_ActivityFishingCeleExchangeCFG::msSingleton(nullptr);

int M_ActivityFishingCeleExchangeCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFishingCeleExchangeCFGData* M_ActivityFishingCeleExchangeCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityFishingCeleExchangeCFGData>& M_ActivityFishingCeleExchangeCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityFishingCeleExchangeCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityFishingCeleExchangeCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFishingCeleExchangeCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mNeedItem = element->IntAttribute("NeedItem");
		data.mNeedCount = element->IntAttribute("NeedCount");
		data.mDiscountCount = element->IntAttribute("DiscountCount");
		data.mItemId = element->IntAttribute("ItemId");
		data.mItemCount = element->IntAttribute("ItemCount");
		data.mLimit = element->IntAttribute("Limit");
		data.mProbItem = element->IntAttribute("ProbItem");
		data.mProbCount = element->IntAttribute("ProbCount");
		data.mProb = element->IntAttribute("Prob");
		data.mGiftDiscount = element->IntAttribute("GiftDiscount");
		data.mLvLimit = element->IntAttribute("LvLimit");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityFishingCeleExchangeCFG::Load()
{
	Load("../Config/M_ActivityFishingCeleExchangeCFG.xml");
}

M_ActivityFishingCeleExchangeCFG* M_ActivityFishingCeleExchangeCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFishingCeleExchangeCFG());
	}
	return msSingleton.get();
}
